program PAS2HTML;
{$I-}{$B-}

{ PAS2HTML
   program pro převod Pascalských zdrojových textů do (X)HTML
   (c) 1996, 2009  Pavel Satrapa}

uses Objects, Dos;

const Verze = '1.10';

      JmenoKlicu = 'keyws.def';
      JmenoZnaku = 'chars.def';

type PKlicSlovo = ^KlicSlovo;
     KlicSlovo = record
       Slovo : string[20];
       Dalsi : PKlicSlovo;
      end;

var JmenoZdroje, JmenoSazby : string;
    Zdroj, Sazba : Text;
    DomaciAdr : string;
    Cislovat,                {číslovat řádky?}
    Komplet,                 {kompletní WWW stránku?}
    Barvit,                  {barvu pozadí?}
    Komentar1,               {ve složených závorkách}
    Komentar2 : Boolean;     {v kulatých s hvězdičkou}
    Kodovani : string;       {jaké kódování se má vyznačit}
    Radek : string;
    CisloR : LongInt;
    BGColor : string [6];
    Klice : array ['A'..'Z'] of PKlicSlovo;
    Znaky : array [Char] of PString;


{*************** podpůrné podprogramy ***************}

procedure Chyba ( Napis : string );
 {vypíše chybové hlášení}
 begin
  Writeln ( '!!! ERROR: ', Napis );
 end;

function NaVelka ( Retezec : string ) : string;
 {převede řetězec na velká písmena}
 {!!! zneužívá toho, že parametr je předáván hodnotou !!!}
 var I : Integer;
 begin
  for I := 1 to Length(Retezec) do
   Retezec[I] := UpCase ( Retezec[I] );
  NaVelka := Retezec;
 end;


{*************** vlastní sazba ***************}

procedure ZpracujRadek;
 {vysází jeden řádek vstupu}
var Pozice : Integer;        {index zpracovávaného znaku}

 procedure PisZnak ( Znak : Char );
  {zapíše do výstupu text, odpovídající danému znaku}
  begin
   Write ( Sazba, Znaky[Znak]^ );
  end;

 procedure PisAPostup;
  {vypíše aktuální znak řádku a popojde na další}
  begin
   PisZnak ( Radek[Pozice] );
   Pozice := Pozice + 1;
  end;

 function PristiZnak : Char;
  {vydá znak, který v řádku následuje za aktuálním}
  begin
   if Pozice < Length(Radek) then
     PristiZnak := Radek[Pozice+1]
    else
     PristiZnak := Chr(0);
  end;

 procedure ZpracujSlovo;
  {načte slovo a vypíše jako identifikátor nebo klíč}

  function JeKlic ( Slovo : string ) : Boolean;
   {je 'Slovo' v tabulce klíčových slov ?}
   var Pom : PKlicSlovo;
       JeToKlic : Boolean;
   begin
    JeToKlic := False;
    Pom := Klice[Slovo[1]];
    while not JeToKlic and (Pom <> nil) do
     if Slovo = Pom^.Slovo then JeToKlic := True
      else Pom := Pom^.Dalsi;
    JeKlic := JeToKlic;
   end;

  var Slovo : string;
  begin                      {ZpracujSlovo}
   Slovo := '';
   while (Pozice <= Length(Radek)) and
         (Radek[Pozice] in ['a'..'z','A'..'Z','_','0'..'9']) do
    begin
     Slovo := Slovo + Radek[Pozice];
     Pozice := Pozice + 1;
    end;
   if JeKlic ( NaVelka(Slovo) ) then
      Write ( Sazba, '<b>', Slovo, '</b>' )
    else
      Write ( Sazba, '<i>', Slovo, '</i>' );
  end;                       {ZpracujSlovo}

 procedure PreskocMezery;
  {vypustí mezery ze začátku řádku}
  var PocetMezer, I : Integer;
      Dal : Boolean;
  begin
   I := 1;
   Dal := I <= Length ( Radek );
   while Dal do
    if Radek[I] <> ' ' then Dal := False
     else
      begin
       I := I + 1;
       Dal := I <= Length ( Radek );
      end;
   PocetMezer := I - 1;
   Delete ( Radek, 1, PocetMezer );
   if Cislovat then
     Write ( Sazba, '<tr><td align="right">&nbsp;<small>', CisloR,
                    '</small>&nbsp;&nbsp;&nbsp;</td><td>' )
    else
     Write ( Sazba, '<tr><td>&nbsp;' );
   if (Radek <> '') and (PocetMezer > 0) then
     begin
      Write ( Sazba, '<tt>' );
      for I := 1 to PocetMezer do
        Write ( Sazba, '&nbsp;' );
      Write ( Sazba, '</tt>' );
     end;
  end;

 procedure DokonciKomentar1;
  {hledá koncovou složenou závorku, text opisuje}
  var Dal : Boolean;
  begin
   Dal := Pozice <= Length(Radek);
   while Dal do
    begin
     if Radek[Pozice] = '}' then
       begin
        Komentar1 := False;
        Dal := False;
       end
      else Dal := Pozice < Length(Radek);
     PisAPostup;
    end;
  end;

 procedure DokonciKomentar2;
  {hledá koncové '*)', text opisuje}
  var Dal : Boolean;
  begin
   Dal := Pozice <= Length(Radek);
   while Dal do
    begin
     if (Radek[Pozice] = '*') and
        (PristiZnak = ')') then
       begin
        PisAPostup;
        Komentar2 := False;
        Dal := False;
       end
      else Dal := Pozice < Length(Radek);
     PisAPostup
    end;
  end;

 procedure DokonciRetezec;
  {hledá ukončující apostrof, text opisuje}
  begin
   repeat
    PisAPostup;
   until Radek[Pozice]='''';
   PisAPostup;
  end;

 begin                       {ZpracujRadek}
  Inc ( CisloR );
  PreskocMezery;
  if Radek <> '' then
    begin
     Pozice := 1;
     if Komentar1 then DokonciKomentar1;
     if Komentar2 then DokonciKomentar2;
     while Pozice <= Length(Radek) do
      case Radek[Pozice] of
        'a'..'z','A'..'Z','_' : ZpracujSlovo;
        '''' : DokonciRetezec;
        '{' : begin
               Write ( Sazba, '&nbsp;&nbsp;&nbsp;' );
               PisAPostup;
               Komentar1 := True;
               DokonciKomentar1;
              end;
        '(' : if PristiZnak <> '*' then PisAPostup
               else
                begin
                 Write ( Sazba, '&nbsp;&nbsp;&nbsp;' );
                 PisAPostup; PisAPostup;
                 Komentar2 := True;
                 DokonciKomentar2;
                end;
        else PisAPostup;
      end;
    end;
  Writeln ( Sazba, '&nbsp;</td></tr>' );
  if IOResult <> 0 then
    Chyba ( 'By write to "' + JmenoSazby + '"' );
 end;                        {ZpracujRadek}


{*************** zahájení, ukončení a spol. ***************}

procedure ZpracujParametry;
 {zpracuje parametry programu}

 procedure NapovedaKonec ( Kod : Integer );
 {návodný text a ukončení programu}
  begin
   Writeln ( ' PAS2HTML ', Verze );
   Writeln ( '===============' );
   Writeln ( 'Program for typesetting Pascal sources in HTML.' );
   Writeln ( '(c) 1996   Pavel Satrapa' );
   Writeln;
   Writeln ( 'Usage: PAS2HTML [input_file [output_file]] [options]' );
   Writeln ( '   default input is standard intput' );
   Writeln ( '   default output is standard output' );
   Writeln ( '   options are:' );
   Writeln ( '    /H           print this Help text' );
   Writeln ( '    /N           include line Numbers to output' );
   Writeln ( '    /C=RRGGBB    bacground color' );
   Writeln ( '    /F           full web page' );
   Writeln ( '    /E=encoding  announce given encoding (default utf=8, valid only with /F)' );
   Halt (Kod);
  end;

 procedure PriradJmeno ( Jmeno : string );
  {přiřazení jména souboru}
  begin
   if JmenoZdroje = '' then JmenoZdroje := Jmeno
    else
     if JmenoSazby = '' then JmenoSazby := Jmeno
      else
       begin
        Chyba ( 'Too much parameters "' + Jmeno + '"' );
        NapovedaKonec (1);
       end;
  end;

 var I : Integer;
     Param : string;
 begin                       {ZpracujParametry}
  JmenoZdroje := '';
  JmenoSazby := '';
  Cislovat := False;
  Komplet := False;
  Barvit := False;
  Kodovani := 'utf-8';
  for I := 1 to ParamCount do
   begin
    Param := ParamStr(I);
    if Param[1] in ['/','-'] then
      case Param[2] of
        'h', 'H', '?' : NapovedaKonec (0);
        'n', 'N' : Cislovat := True;
        'f', 'F' : Komplet := True;
        'e', 'E' : Kodovani := Copy ( Param, 4, Length(Param) - 3 );
        'c', 'C' : begin
                    Barvit := True;
                    BGColor := Copy ( Param, 4, 6 );
                   end;
        else
         begin
          Chyba ( 'Bad parameter "' + Param + '"' );
          NapovedaKonec (1);
         end;
      end
     else
      PriradJmeno ( Param );
   end;
 end;                        {ZpracujParametry}

procedure Inicializace;
{počáteční inicializace programu}

 procedure UrciAdresar;
  {najde adresář, ve kterém se nachází program}
  var
    EXEJmeno: PathStr;
    Jmeno : NameStr;
    Pripona : ExtStr;
  begin
   EXEJmeno := ParamStr(0);
   FSplit(EXEJmeno, DomaciAdr, Jmeno, Pripona);
{  if DomaciAdr [ Length(DomaciAdr) ] <> '\' then
     DomaciAdr := DomaciAdr + '\';   }
  end;

 procedure NactiKlice;
 {načte ze souboru klíčová slova a inicalizuje 'Klice'}

  procedure PridejKlic ( KlSlovo : string );
  {přidá 'KlSlovo' do tabulky klíčových slov}
   var NovyKlic : PKlicSlovo;
   begin
    New ( NovyKlic );
    NovyKlic^.Slovo := KlSlovo;
    NovyKlic^.Dalsi := Klice[KlSlovo[1]];
    Klice[KlSlovo[1]] := NovyKlic;
   end;

  var C : Char;
      KlSoub : Text;
      Radek : string;
  begin                      {NactiKlice}
   for C := 'A' to 'Z' do Klice[C] := nil;
   Assign ( KlSoub, DomaciAdr + JmenoKlicu );
   Reset ( KlSoub );
   if IOResult <> 0 then
     Chyba ( 'Cannot open keyword file "' + JmenoKlicu + '"' );
   while not Eof(KlSoub) do
    begin
     Readln ( KlSoub, Radek );
     if Pos ( ' ', Radek ) <> 0 then
       Delete ( radek, Pos(' ',Radek), Length(Radek) );
     if Radek <> '' then PridejKlic ( NaVelka(Radek) );
    end;
   Close ( KlSoub );
   if IOResult <> 0 then
     Chyba ( 'By reading keyword file "' + JmenoKlicu + '"' );
  end;                       {NactiKlice}

 procedure NactiZnaky;
 {načte definice speciálních znaků}
  var C : Char;
      ZnSoub : Text;
      Radek : string;
  begin
   for C := Chr(0) to Chr(255) do
     Znaky[C] := nil;
   Assign ( ZnSoub, DomaciAdr + JmenoZnaku );
   Reset ( ZnSoub );
   if IOResult <> 0 then
     Chyba ( 'Cannot open char definiton file "' + JmenoZnaku + '"' );
   while not Eof(ZnSoub) do
    begin
     Readln ( ZnSoub, Radek );
     if Radek <> '' then
      begin
       C := Radek[1];
       Delete ( Radek, 1, 2 );
       Znaky[C] := NewStr ( Radek );
      end;
    end;
   Close ( ZnSoub );
   if IOResult <> 0 then
     Chyba ( 'By reading char definiton file "' + JmenoZnaku + '"' );
   for C := Chr(0) to Chr(255) do
     if Znaky[C] = nil then Znaky[C] := NewStr ( C );
  end;

 begin                       {Inicializace}
  UrciAdresar;
  NactiKlice;
  NactiZnaky;
  Komentar1 := False;
  Komentar2 := False;
  CisloR := 0;
  Assign ( Zdroj, JmenoZdroje );
  Reset ( Zdroj );
  if IOResult <> 0 then
    Chyba ( 'Cannot open input file "' + JmenoZdroje + '"' );
  Assign ( Sazba, JmenoSazby );
  Rewrite ( Sazba );
  if IOResult <> 0 then
    Chyba ( 'Cannot open output file "' + JmenoSazby + '"' );
  if Komplet then
    begin
    Writeln ( Sazba, '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"');
    Writeln ( Sazba, '    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">');
    Writeln ( Sazba, '<html xmlns="http://www.w3.org/1999/xhtml">');
    Writeln ( Sazba, '<head>');
    Writeln ( Sazba, '<meta http-equiv="content-type" content="text/html; charset=',
                     Kodovani, '" />');
    Writeln ( Sazba, '<title>', JmenoZdroje, '</title>');
    Writeln ( Sazba, '</head>');
    Writeln ( Sazba, '<body>');
    Writeln ( Sazba, '<h1>', JmenoZdroje, '</h1>');
    end;
  Write ( Sazba, '<table border="0" cellspacing="0" cellpadding="0"' );
  if Barvit then
    Write ( Sazba, ' bgcolor="#', BGColor, '"' );
  Writeln ( Sazba, '>' );
  if IOResult <> 0 then
    Chyba ( 'By writing to "' + JmenoSazby + '"' );
 end;                        {Inicializace}

procedure Konec;
{zakončení programu}
 begin
  Close ( Zdroj );
  if IOResult <> 0 then
    Chyba ( 'Cannot close input "' + JmenoZdroje + '"' );
  Writeln ( Sazba, '</table>' );
  if Komplet then
    begin
    Writeln ( Sazba, '</body>');
    Writeln ( Sazba, '</html>');
    end;
  if IOResult <> 0 then
    Chyba ( 'By writing to "' + JmenoSazby + '"' );
  Close ( Sazba );
  if IOResult <> 0 then
    Chyba ( 'Cannot close output "' + JmenoSazby + '"' );
 end;


{*************** hlavní program ***************}

begin
 ZpracujParametry;
 Inicializace;
 while not Eof(Zdroj) do
  begin
   Readln ( Zdroj, Radek );
   if IOResult <> 0 then
     Chyba ( 'By reading from "' + JmenoSazby + '"' );
   ZpracujRadek;
  end;
 Konec;
end.
